Bugzilla will be upgraded to version 5.0. The upgrade date is tentatively scheduled for 2 December 2018, pending final testing and feedback.
Bug 615701 - RHEL 6 beta 2 glibc does not load nosegneg libraries on a 32-bit Xen domU system
RHEL 6 beta 2 glibc does not load nosegneg libraries on a 32-bit Xen domU system
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: glibc (Show other bugs)
6.0
All Linux
low Severity medium
: rc
: ---
Assigned To: Andreas Schwab
qe-baseos-tools
: Regression
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-07-18 01:10 EDT by Matt Wilson
Modified: 2016-11-24 10:41 EST (History)
5 users (show)

See Also:
Fixed In Version: glibc-2.12-1.12.el6
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-05-19 09:15:51 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2011:0584 normal SHIPPED_LIVE glibc bug fix and enhancement update 2011-05-18 13:56:51 EDT

  None (edit)
Description Matt Wilson 2010-07-18 01:10:18 EDT
Description of problem:
When running in a 32-bit Xen domU environment, glibc does not load the nosegneg libraries when "hwcap 1 nosegneg" is in /etc/ld.so.conf.d/nosegneg.conf

Version-Release number of selected component (if applicable): 2.12-1.2.el6

How reproducible: 100%


Steps to Reproduce (on Xen domU):
1. # echo hwcap 1 nosegneg > /etc/ld.so.conf.d/nosegneg.conf
2. # ldconfig
3. # ldd /bin/true
  
Actual results:
        linux-gate.so.1 =>  (0xb7798000)
        libc.so.6 => /lib/libc.so.6 (0xb76bb000)
        /lib/ld-linux.so.2 (0xb7799000)


Expected results:
        linux-gate.so.1 =>  (0xb7798000)
        libc.so.6 => /lib/i686/nosegneg/libc.so.6 (0xb7624000)
        /lib/ld-linux.so.2 (0xb7799000)

Additional info:

This bug was introduced in http://sourceware.org/git/?p=glibc.git;a=commitdiff;h=7bfa311ff51999f9e92620268e493959a2f7bfb4 

Rolling back this change corrects the behavior.
Comment 2 RHEL Product and Program Management 2010-07-18 01:37:51 EDT
This issue has been proposed when we are only considering blocker
issues in the current Red Hat Enterprise Linux release. It has
been denied for the current Red Hat Enterprise Linux release.

** If you would still like this issue considered for the current
release, ask your support representative to file as a blocker on
your behalf. Otherwise ask that it be considered for the next
Red Hat Enterprise Linux release. **
Comment 3 Roland McGrath 2010-07-19 19:33:25 EDT
Probably fixed by:

diff --git a/elf/dl-sysdep.c b/elf/dl-sysdep.c
index 160503d..75cb310 100644
--- a/elf/dl-sysdep.c
+++ b/elf/dl-sysdep.c
@@ -425,6 +425,7 @@ _dl_important_hwcaps (const char *platform, size_t platform_len, size_t *sz,
     {
       const ElfW(Word) mask = ((const ElfW(Word) *) dsocaps)[-1];
       GLRO(dl_hwcap) |= (uint64_t) mask << _DL_FIRST_EXTRA;
+      GLRO(dl_hwcap_mask) |= (uint64_t) mask << _DL_FIRST_EXTRA;
       size_t len;
       for (const char *p = dsocaps; p < dsocaps + dsocapslen; p += len + 1)
 	{

Note this does not permit for LD_HWCAP_MASK environment variable constraining vDSO capabilities used.
Comment 4 Matt Wilson 2010-07-19 20:08:24 EDT
testing a patched glibc now.
Comment 5 Matt Wilson 2010-07-20 14:02:41 EDT
tested this yesterday and forgot to report back. This does seem to fix the problem.
Comment 6 Andreas Schwab 2010-07-28 11:08:32 EDT
5dbc3b6cc0b759bf4b22d851ccb9cbf3e3cbc6ef
Comment 11 errata-xmlrpc 2011-05-19 09:15:51 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2011-0584.html

Note You need to log in before you can comment on or make changes to this bug.